package hk.quantr.fs;

import hk.quantr.Dialogs.SearchDialog;
import hk.quantr.fs.Dialogs.FillDialog;
import hk.quantr.fs.Dialogs.SearchTextDialog;
import hk.quantr.peterswing.CommonLib;
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.ClipboardOwner;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.HashMap;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.table.TableColumn;
import javax.swing.undo.UndoManager;

/**
 *
 * @author Peter <peter@quantr.hk>
 */
public class PFSFilePropertyPanel2 extends javax.swing.JPanel implements Runnable, ClipboardOwner {

	JFrame jMainFrame = new JFrame();
	File selectedFile;
	SearchTextDialog pSearchTextDialog;
	boolean stopFileLoading;
	public boolean shouldSave;
	UndoManager m_undoManager = new UndoManager();
	HexTableModel jHexTableModel = new HexTableModel();

	public PFSFilePropertyPanel2(MainFrame2 jMainFrame, String projectFile, File selectedFile) {
		this(jMainFrame, new File(projectFile), selectedFile);
	}

	public PFSFilePropertyPanel2(MainFrame2 jMainFrame, File projectFile, File selectedFile) {
		super();
		initComponents();
		this.jMainFrame = jMainFrame;
		this.selectedFile = selectedFile;
		pFSPermissionPanel1 = new PFSPermissionPanel(projectFile, selectedFile);
		pFSOwnerPanel1 = new PFSOwnerPanel(jMainFrame, projectFile, selectedFile);
		pFSCreateTimeAndLastModifiedTimePanel1 = new PFSCreateTimeAndLastModifiedTimePanel(projectFile, selectedFile);

		// search for the node number
		SearchDialog pSearchDialog = new SearchDialog();
		Vector<HashMap<String, String>> vector = new Vector<HashMap<String, String>>();
		pSearchDialog.pFilenameOrDirectoryNameTextField.setText("/" + new File(PFSSettingConstants.tempDirectory).getName() + selectedFile.getAbsolutePath().substring(PFSSettingConstants.tempDirectory.length()).replaceAll("\\\\", "/"));
		pSearchDialog.searchPFS(pSearchDialog.SEARCH_BY_FILENAME_OR_DIRECTORY_NAME, vector);
		if (vector.size() > 0) {
			this.pNodeNoLabel.setText("Node number : " + vector.get(0).get("blockNumber"));
		}
		// end search for the node number
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane = new javax.swing.JTabbedPane();
        pCharPanel = new javax.swing.JPanel();
        jToolBar1 = new javax.swing.JToolBar();
        pRevertToolBarButton = new javax.swing.JButton();
        pSaveToolBarButton = new javax.swing.JButton();
        pCopyToolBarButton = new javax.swing.JButton();
        pCutToolBarButton = new javax.swing.JButton();
        pPasteToolBarButton = new javax.swing.JButton();
        pUndoToolBarButton = new javax.swing.JButton();
        pRedoToolBarButton = new javax.swing.JButton();
        pSearchToolBarButton = new javax.swing.JButton();
        pFillToolBarButton = new javax.swing.JButton();
        pLineWrapToggleButton = new javax.swing.JToggleButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        imagePanel = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        imageLabel = new javax.swing.JLabel();
        hexScrollPane = new javax.swing.JScrollPane();
        pHexTable = new javax.swing.JTable();
        pFilePropertyPanel = new javax.swing.JPanel();
        pFSPermissionPanel1 = new hk.quantr.fs.PFSPermissionPanel();
        pFSOwnerPanel1 = new hk.quantr.fs.PFSOwnerPanel();
        pFSCreateTimeAndLastModifiedTimePanel1 = new hk.quantr.fs.PFSCreateTimeAndLastModifiedTimePanel();
        pNodeNoPanel = new javax.swing.JPanel();
        pNodeNoLabel = new javax.swing.JLabel();
        pFilesizeLabel = new javax.swing.JLabel();
        pFileLoadingPanel = new javax.swing.JPanel();
        jProgressBar1 = new javax.swing.JProgressBar();
        cancelButton = new javax.swing.JButton();
        pFileLabel = new javax.swing.JLabel();

        setLayout(new java.awt.BorderLayout());

        jTabbedPane.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTabbedPaneMouseClicked(evt);
            }
        });

        pCharPanel.setLayout(new java.awt.BorderLayout());

        jToolBar1.setRollover(true);

        pRevertToolBarButton.setText("Revert");
        pRevertToolBarButton.setFocusable(false);
        pRevertToolBarButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        pRevertToolBarButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        pRevertToolBarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pRevertToolBarButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(pRevertToolBarButton);

        pSaveToolBarButton.setText("Save");
        pSaveToolBarButton.setFocusable(false);
        pSaveToolBarButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        pSaveToolBarButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        pSaveToolBarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pSaveToolBarButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(pSaveToolBarButton);

        pCopyToolBarButton.setText("Copy");
        pCopyToolBarButton.setFocusable(false);
        pCopyToolBarButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        pCopyToolBarButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        pCopyToolBarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pCopyToolBarButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(pCopyToolBarButton);

        pCutToolBarButton.setText("Cut");
        pCutToolBarButton.setFocusable(false);
        pCutToolBarButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        pCutToolBarButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        pCutToolBarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pCutToolBarButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(pCutToolBarButton);

        pPasteToolBarButton.setText("Paste");
        pPasteToolBarButton.setFocusable(false);
        pPasteToolBarButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        pPasteToolBarButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        pPasteToolBarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pPasteToolBarButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(pPasteToolBarButton);

        pUndoToolBarButton.setText("Undo");
        pUndoToolBarButton.setFocusable(false);
        pUndoToolBarButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        pUndoToolBarButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        pUndoToolBarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pUndoToolBarButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(pUndoToolBarButton);

        pRedoToolBarButton.setText("Redo");
        pRedoToolBarButton.setFocusable(false);
        pRedoToolBarButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        pRedoToolBarButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        pRedoToolBarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pRedoToolBarButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(pRedoToolBarButton);

        pSearchToolBarButton.setText("Search");
        pSearchToolBarButton.setFocusable(false);
        pSearchToolBarButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        pSearchToolBarButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        pSearchToolBarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pSearchToolBarButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(pSearchToolBarButton);

        pFillToolBarButton.setText("Fill");
        pFillToolBarButton.setFocusable(false);
        pFillToolBarButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        pFillToolBarButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        pFillToolBarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pFillToolBarButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(pFillToolBarButton);

        pLineWrapToggleButton.setText("Wrap");
        pLineWrapToggleButton.setFocusable(false);
        pLineWrapToggleButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        pLineWrapToggleButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        pLineWrapToggleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pLineWrapToggleButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(pLineWrapToggleButton);

        pCharPanel.add(jToolBar1, java.awt.BorderLayout.PAGE_START);

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jTextArea1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextArea1KeyReleased(evt);
            }
        });
        jScrollPane1.setViewportView(jTextArea1);

        pCharPanel.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jTabbedPane.addTab("Char", pCharPanel);

        imagePanel.setLayout(new java.awt.BorderLayout());

        jScrollPane3.setViewportView(imageLabel);

        imagePanel.add(jScrollPane3, java.awt.BorderLayout.CENTER);

        jTabbedPane.addTab("Image", imagePanel);

        pHexTable.setModel(jHexTableModel);
        hexScrollPane.setViewportView(pHexTable);

        jTabbedPane.addTab("Hex", hexScrollPane);

        pFilePropertyPanel.setLayout(new javax.swing.BoxLayout(pFilePropertyPanel, javax.swing.BoxLayout.Y_AXIS));
        pFilePropertyPanel.add(pFSPermissionPanel1);
        pFilePropertyPanel.add(pFSOwnerPanel1);
        pFilePropertyPanel.add(pFSCreateTimeAndLastModifiedTimePanel1);

        pNodeNoPanel.add(pNodeNoLabel);

        pFilePropertyPanel.add(pNodeNoPanel);

        pFilesizeLabel.setText("File size : 0 , 0 bytes");
        pFilePropertyPanel.add(pFilesizeLabel);

        jTabbedPane.addTab("Properties", pFilePropertyPanel);

        add(jTabbedPane, java.awt.BorderLayout.CENTER);

        pFileLoadingPanel.setLayout(new java.awt.BorderLayout());
        pFileLoadingPanel.add(jProgressBar1, java.awt.BorderLayout.CENTER);

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });
        pFileLoadingPanel.add(cancelButton, java.awt.BorderLayout.LINE_END);

        pFileLabel.setText("file size: 0");
        pFileLoadingPanel.add(pFileLabel, java.awt.BorderLayout.PAGE_END);

        add(pFileLoadingPanel, java.awt.BorderLayout.SOUTH);
    }// </editor-fold>//GEN-END:initComponents

    private void pRevertToolBarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pRevertToolBarButtonActionPerformed
		if (selectedFile != null) {
			stopFileLoading = false;
			new Thread(this).start();
		}
    }//GEN-LAST:event_pRevertToolBarButtonActionPerformed

    private void pSaveToolBarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pSaveToolBarButtonActionPerformed
		saveFile();
    }//GEN-LAST:event_pSaveToolBarButtonActionPerformed

    private void pCopyToolBarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pCopyToolBarButtonActionPerformed
		setClipboardContents(jTextArea1.getSelectedText());
    }//GEN-LAST:event_pCopyToolBarButtonActionPerformed

    private void pCutToolBarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pCutToolBarButtonActionPerformed
		setClipboardContents(jTextArea1.getSelectedText());
		jTextArea1.replaceSelection("");
    }//GEN-LAST:event_pCutToolBarButtonActionPerformed

    private void pPasteToolBarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pPasteToolBarButtonActionPerformed
		jTextArea1.replaceSelection(getClipboardContents());
    }//GEN-LAST:event_pPasteToolBarButtonActionPerformed

    private void pUndoToolBarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pUndoToolBarButtonActionPerformed
		try {
			m_undoManager.undo();
		} catch (Exception ex) {
			ex.printStackTrace();
			if (Global.GUI) {
				new PExceptionDialog(ex, Global.sessionNumber).setVisible(true);
			}
		}
		updateUndoButtons();
    }//GEN-LAST:event_pUndoToolBarButtonActionPerformed

    private void pRedoToolBarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pRedoToolBarButtonActionPerformed
		try {
			m_undoManager.redo();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		updateUndoButtons();
    }//GEN-LAST:event_pRedoToolBarButtonActionPerformed

    private void pSearchToolBarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pSearchToolBarButtonActionPerformed
		try {
			// String searchText = JOptionPane.showInputDialog(this, "Text : ",
			// "Search",
			// JOptionPane.INFORMATION_MESSAGE);
			// if (searchText.length() > 0) {
			// for (int x = 0; x < jEditorPane.getText().length() -
			// searchText.length(); x++) {
			// if (jEditorPane.getText().substring(x, x + searchText.length() -
			// 1).equals(searchText)) {
			// jEditorPane.setSelectionStart(x);
			// jEditorPane.setSelectionEnd(x + searchText.length() - 1);
			// return;
			// }
			// }
			// }
			pSearchTextDialog.setVisible(true);

		} catch (Exception ex) {

		}
    }//GEN-LAST:event_pSearchToolBarButtonActionPerformed

    private void pFillToolBarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pFillToolBarButtonActionPerformed
		FillDialog pFillDialog = new FillDialog(jMainFrame, "Fill", true);
		PFSCommonLib.centerDialog(pFillDialog);
		pFillDialog.setVisible(true);
		if (pFillDialog.isCancel() == false) {
			char from = 0;
			char to = 0;
			if (pFillDialog.isChar()) {
				from = pFillDialog.getFromChar();
				to = pFillDialog.getToChar();
			} else {
				from = (char) pFillDialog.getFromAscii();
				to = (char) pFillDialog.getToAscii();
			}
			char c = from;
			StringBuffer buffer = new StringBuffer(pFillDialog.getNumberOfByte());
			buffer.append("");
			for (int x = 0; x < pFillDialog.getNumberOfByte(); x++) {
				buffer.append(c);
				c++;
				if (c == to + 1) {
					c = from;
				}
			}

			jTextArea1.setText(jTextArea1.getText().substring(0, jTextArea1.getSelectionStart()) + buffer + jTextArea1.getText().substring(jTextArea1.getSelectionStart()));
			jTextArea1KeyReleased(null);
		}
    }//GEN-LAST:event_pFillToolBarButtonActionPerformed

    private void pLineWrapToggleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pLineWrapToggleButtonActionPerformed
		jTextArea1.setLineWrap(!pLineWrapToggleButton.isSelected());
    }//GEN-LAST:event_pLineWrapToggleButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
		// TODO add your handling code here:
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void jTabbedPaneMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTabbedPaneMouseClicked
		if (jTabbedPane.getSelectedComponent() == hexScrollPane) {
			binary();
		}
    }//GEN-LAST:event_jTabbedPaneMouseClicked

    private void jTextArea1KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextArea1KeyReleased
		shouldSave = true;
		pFileLabel.setText("file size: " + jTextArea1.getText().length());
    }//GEN-LAST:event_jTextArea1KeyReleased

	public void binary() {
		System.out.println("Updating hex table");
		Thread binary_thread = new Thread() {
			public void run() {
				try {
					int row = jTextArea1.getText().length() / 15;
					int x, y;
					int left = 0, con;
					String buffer = "";

					RandomAccessFile br = new RandomAccessFile(selectedFile, "r");
					byte data[] = new byte[(int) selectedFile.length()];
					br.read(data);
					br.close();

					TableColumn column = null;

					int max = (int) selectedFile.length(); // qwe.length();
					String qw[][];
					if ((int) selectedFile.length() % 16 == 0) {
						qw = new String[18][(int) selectedFile.length() / 16];
					} else {
						qw = new String[18][(int) selectedFile.length() / 16 + 1];
					}

					jProgressBar1.setMaximum(max * 2);
					jProgressBar1.setValue(0);
					pFileLoadingPanel.setVisible(true);
					for (con = 0, x = 0, y = 0; con < max;) {
						switch (x) {
							case 0:
								qw[x][y] = (String) Integer.toHexString(left);
								left += 0x10;
								x++;
								break;
							case 17:
								qw[x][y] = buffer;
								buffer = "";
								y++;
								x = 0;
								jProgressBar1.setValue(jProgressBar1.getValue() + 15);
								break;
							default:
								buffer += (char) data[con];
								qw[x][y] = (String) Integer.toHexString((byte) data[con] & 0xff);
								con++;
								x++;
						}
					}
					qw[17][qw[0].length - 1] = buffer;

					if ((int) selectedFile.length() % 16 == 0) {
						jHexTableModel.set(qw, (int) selectedFile.length() / 16);
					} else {
						jHexTableModel.set(qw, (int) selectedFile.length() / 16 + 1);
					}
					jHexTableModel.fireTableDataChanged();
					jProgressBar1.setValue(jProgressBar1.getMaximum());
					pFileLoadingPanel.setVisible(false);
					for (int i = 0; i <= 16; i++) {
						column = pHexTable.getColumnModel().getColumn(i);
						if (i == 0) {
							column.setPreferredWidth(100);
						} else {
							column.setPreferredWidth(50);
						}
					}
				} catch (Exception eee) {
					eee.printStackTrace();
				}
			}
		};
		binary_thread.start();
	}

	private void updateUndoButtons() {
		System.out.println("a");
		pUndoToolBarButton.setText(m_undoManager.getUndoPresentationName());
		System.out.println("b");
		pRedoToolBarButton.setText(m_undoManager.getRedoPresentationName());
		System.out.println("c");
		pUndoToolBarButton.setEnabled(m_undoManager.canUndo());
		System.out.println("d");
		pRedoToolBarButton.setEnabled(m_undoManager.canRedo());
		System.out.println("e");
	}

	@Override
	public void run() {
		try {
			if (selectedFile.isFile()) {
				jProgressBar1.setValue(0);
				jProgressBar1.setMaximum((int) selectedFile.length());

				if (CommonLib.isImage(selectedFile)) {
					ImageIcon imageicon = new ImageIcon(selectedFile.getAbsolutePath());
					imageLabel.setIcon(imageicon);
					pFileLabel.setText(String.valueOf(selectedFile.length()));
					jTabbedPane.setSelectedIndex(1);
				} else {
					BufferedReader br = new BufferedReader(new FileReader(selectedFile));
					pFileLoadingPanel.setVisible(true);
					jTextArea1.setEnabled(false);
					jTextArea1.setText(null);

					// /////////////////////////////////
					// FileInputStream fis = new FileInputStream(selectedFile);
					// DefaultEditorKit k = new DefaultEditorKit();
					// DefaultStyledDocument doc = new DefaultStyledDocument();
					// k.read(fis, doc, 0);
					// jEditorPane1.setDocument(doc);
					// /////////////////////////////////
					StringBuffer str = new StringBuffer((int) selectedFile.length());
					char tempC[] = new char[4096];
					int len;
					while ((len = br.read(tempC)) > 0 && !stopFileLoading) {
						jProgressBar1.setValue(jProgressBar1.getValue() + str.length());
						str.append(new String(tempC, 0, len));
					}
					jTextArea1.setText(str.toString());
					jTextArea1.setEnabled(true);
					pFileLoadingPanel.setVisible(false);
					br.close();
					pFileLabel.setText(String.valueOf(jTextArea1.getText().length()));
					jTabbedPane.setSelectedIndex(0);
				}
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			if (Global.GUI) {
				new PExceptionDialog(ex, Global.sessionNumber).setVisible(true);
			}
		}
	}

	public void saveFile() {
		try {
			if (selectedFile != null) {
				BufferedWriter bw = new BufferedWriter(new FileWriter(selectedFile));
				bw.write(jTextArea1.getText());
				bw.close();
				shouldSave = false;
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			if (Global.GUI) {
				new PExceptionDialog(ex, Global.sessionNumber).setVisible(true);
			}
		}
	}

	public void loadFile() {
		new Thread(this).start();
	}

	public void setClipboardContents(String aString) {
		StringSelection stringSelection = new StringSelection(aString);
		Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
		clipboard.setContents(stringSelection, this);
	}

	public String getClipboardContents() {
		String result = "";
		Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
		// odd: the Object param of getContents is not currently used
		Transferable contents = clipboard.getContents(null);
		boolean hasTransferableText = (contents != null) && contents.isDataFlavorSupported(DataFlavor.stringFlavor);
		if (hasTransferableText) {
			try {
				result = (String) contents.getTransferData(DataFlavor.stringFlavor);
			} catch (UnsupportedFlavorException ex) {
				// highly unlikely since we are using a standard DataFlavor
				ex.printStackTrace();
				if (Global.GUI) {
					new PExceptionDialog(ex, Global.sessionNumber).setVisible(true);
				}
			} catch (IOException ex) {
				ex.printStackTrace();
				if (Global.GUI) {
					new PExceptionDialog(ex, Global.sessionNumber).setVisible(true);
				}
			}
		}
		return result;
	}


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JScrollPane hexScrollPane;
    private javax.swing.JLabel imageLabel;
    private javax.swing.JPanel imagePanel;
    private javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTabbedPane jTabbedPane;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JPanel pCharPanel;
    private javax.swing.JButton pCopyToolBarButton;
    private javax.swing.JButton pCutToolBarButton;
    private hk.quantr.fs.PFSCreateTimeAndLastModifiedTimePanel pFSCreateTimeAndLastModifiedTimePanel1;
    private hk.quantr.fs.PFSOwnerPanel pFSOwnerPanel1;
    private hk.quantr.fs.PFSPermissionPanel pFSPermissionPanel1;
    private javax.swing.JLabel pFileLabel;
    private javax.swing.JPanel pFileLoadingPanel;
    private javax.swing.JPanel pFilePropertyPanel;
    private javax.swing.JLabel pFilesizeLabel;
    private javax.swing.JButton pFillToolBarButton;
    private javax.swing.JTable pHexTable;
    private javax.swing.JToggleButton pLineWrapToggleButton;
    private javax.swing.JLabel pNodeNoLabel;
    private javax.swing.JPanel pNodeNoPanel;
    private javax.swing.JButton pPasteToolBarButton;
    private javax.swing.JButton pRedoToolBarButton;
    private javax.swing.JButton pRevertToolBarButton;
    private javax.swing.JButton pSaveToolBarButton;
    private javax.swing.JButton pSearchToolBarButton;
    private javax.swing.JButton pUndoToolBarButton;
    // End of variables declaration//GEN-END:variables

	@Override
	public void lostOwnership(Clipboard clipboard, Transferable contents) {
		throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
	}
}
